function Create(self)
	--lag fixing
	self.LagTimer = Timer()
	self.laglimiter = 300
	--animation vars
	self.spriteTimer = Timer()
	self.spritelimiter = 150
	--TODO: Gas release.
	self.GasTimer = Timer()
	--list of usable gas particles
	self.gasshowcase = {"Zombie GreenSplosion Micro MOSP Down", "Zombie GreenSplosion Micro MOSP Up", "Zombie Green Gas Emitter Sink",
							"Zombie RedSplosion Small MOSP Down", "Zombie GreenSplosion Tiny MOSP Down Flipped"}
	--glow stuff
	self.glowshowcase = {"Buff Glow A", "Buff Glow B"}
	-- zombie levels - for respawning. THIS WILL BE SO MUCH EASIER ONCE I MAKE RANDOM ACTORS
	self.lvl0 = {"Lost Docile Zombie", "Stumbly Docile Zombie", "Brain-Dead Docile Zombie"}
	self.lvl1 = {"Short-Sighted Raging Zombie", "Jawless Raging Zombie"}
	self.lvl2 = {"Complete Zombie"}
	self.lvlE = {"Engineer Zombie"}
	
	--filling the buff table
	self.bufftable = {}
	for actor in MovableMan.Actors do
		if actor:IsInGroup("Zombies") and string.find(actor.PresetName, "Zombie") and (actor.Pos - self.Pos).Magnitude <= 400 then
			table.insert(self.bufftable,actor)
		end
	end
	
end

function Update(self)
	-- lua based animation (its pinned)
	if self.spriteTimer:IsPastSimMS(self.spritelimiter) then
		if self.Frame < self.FrameCount then
			self.Frame = self.Frame + 1
		else
			self.Frame = 1
		end
		self.spriteTimer:Reset()
	end
	-- dont settle rawr
	self:NotResting()
	self.ToDelete = false
	self.ToSettle = false
	self.Age = 0;
	
	if self.LagTimer:IsPastSimMS(self.laglimiter) then
		--making sure the bufftable is up to date.
		self.bufftable = {}
		for actor in MovableMan.Actors do
			if actor:IsInGroup("Zombies") and string.find(actor.PresetName, "Zombie") and (actor.Pos - self.Pos).Magnitude <= 400 then
				table.insert(self.bufftable,actor)
			end
		end
		self.LagTimer:Reset()
	end
	
	if self.bufftable ~= {} then
	for k,actor in ipairs(self.bufftable) do
		if MovableMan:ValidMO(actor) and actor:IsActor() then
			actor.bufflevel = 0.15 / ((actor.Pos - self.Pos).Magnitude / 400)
			if string.find(actor.PresetName, "Docile") then
				actor.lvl = -1
			elseif string.find(actor.PresetName, "Bloated") then
				actor.lvl = -1
			elseif string.find(actor.PresetName, "Raging") then
				actor.lvl = self.lvl0
			elseif string.find(actor.PresetName, "Complete") then
				actor.lvl = self.lvl1
			elseif string.find(actor.PresetName, "Engineer Zombie") then
				actor.lvl = self.lvlE
			else
				actor.lvl = -1
			end
			--regen health
			if actor.Health ~= nil and actor.Health > 0 then
				if (actor.Health < 100 and math.random(actor.Health/4) < 3) and not actor:IsDead() then
					actor.Health = actor.Health + ((400 / (actor.Pos - self.Pos).Magnitude))
					if actor.Health > 100 then
						actor.Health = 100
					end
				end
			end
			--if by some miracle you kill the bastard (without gibbing), respawn.
			if (actor:IsDead() or actor.ToSettle) and actor.lvl ~= -1 then
				--setup a new zombie
				newactor = CreateAHuman(actor.lvl[math.floor(math.random(1,(#actor.lvl)))], "Zombies.rte")
				newactor.Pos = actor.Pos
				newactor.Team = actor.Team
				newactor.Health = math.random(40,80)
				newactor:SetWhichMOToNotHit(actor,-1)
				--gib and remove the old actor..
				actor:GibThis()
				table.remove(self.bufftable,k)
				--and spawn a lower one :)
				MovableMan:AddActor(newactor)
				table.insert(self.bufftable, newactor)
			end
			--more buffing stuff here
			--glow stuff
			actor.glowparticle = CreateMOPixel (self.glowshowcase[math.random(#self.glowshowcase)], "Zombies.rte")
			actor.glowparticle.Pos = actor.Pos + Vector(math.random(-5,5),math.random(-5,5))
			actor.glowparticle.Lifetime = math.random(80,130)
			MovableMan:AddParticle(actor.glowparticle);
		else
			--no point having useless data stick around.
			table.remove(self.bufftable,k)
		end
	end
	end
end

function Destroy(self)

end
